<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Lab02</title>
</head>
<body>
<script type="text/javascript">
        var vehicleName = 'Toyota';

        function printVehicleNameOuter(){
            console.log(this.vehicleName);
        }



        printVehicleNameOuter(); //this prints Toyota(Window Object)

        var Vehicle = {
            vehicleName : 'nissan',
            printVehicleNameInner : function(){
                return function(){
                    console.log(this.vehicleName);
                }
            }
        }

        //console.log(Vehicle.printVehicleNameInner());

        var execute = Vehicle.printVehicleNameInner();
        execute();

        console.log("===================================================");

        Vehicle.printVehicleNameInner().call(Vehicle); //returns nissan, This allows to attach object in runtime
        Vehicle.printVehicleNameInner().call();     //returns Toyota

        execute = Vehicle.printVehicleNameInner().bind(Vehicle); //this allows to attach object when assigning
        execute();// returns nissan

        console.log("===================================================");

         function taxCalcultor(taxPercentage){
                return function(amount){
                    return(amount*taxPercentage/100);
                }
         }

         var amntreturner = taxCalcultor(20);   //this way, we can encapsulate data as taxPercentage is
                                                //not visible in each amntreturn() call
         console.log(amntreturner(1000));

        console.log("===================================================");

        function fetchUsers(){
            fetch('https://api.github.com/users').then(function (response) {
                return response.json();
            }).then(function(json){
                console.log(json);
            });
        }
        //fetchUsers();

        console.log("===================================================");


        console.log("===================================================");

        function fetchUsers() {
            return fetch('https://api.github.com/users')
                .then(response => response.json());
        }
        fetchUsers().then(function (json) {
            console.log(json);
        });
        console.log("================================================");

        function Vehicle(type){             //Vehicle class
            Vehicle.VehicleCount++;
            this.type = type;
        }

        Vehicle.VehicleCount=0;

        Vehicle.prototype.drive = function(){
            console.log("Vehicle is driving");
        };

        var vehicle = new Vehicle('Nissan');

        function Car(type){                     //Car class
            Vehicle.call(this,type);
        }

        Car.prototype =  Object.create(Vehicle.prototype);
        Car.prototype.constructor = Car;
        Car.prototype.balanceWheels = function(){
            console.log('Wheels are balanced');
        };

        var MyCar = new Car('Mazda');
        MyCar.drive();
        MyCar.balanceWheels();
        console.log(MyCar.type, Vehicle.VehicleCount);

        console.log("===================================================");

</script>
</body>
</html>